=== debian/changelog ===
wpa (2:2.6-15ubuntu2.8+esm1) bionic-security; urgency=medium

  * SECURITY UPDATE: loading arbitrary shared objects, privilege escalation
    - debian/patches/lib_engine_trusted_path.patch: Allow shared objects
      to only be loaded from /usr/lib, thanks to mdeslaur
    - CVE-2024-5290

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Mon, 05 Aug 2024 19:58:52 +0530

wpa (2:2.6-15ubuntu2.8) bionic-security; urgency=medium

  * SECURITY UPDATE: DoS and possible code execution via P2P provision
    discovery requests
    - debian/patches/CVE-2021-27803.patch: fix a corner case in peer
      addition based on PD Request in src/p2p/p2p_pd.c.
    - CVE-2021-27803

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 01 Mar 2021 08:45:44 -0500

wpa (2:2.6-15ubuntu2.7) bionic-security; urgency=medium

  * SECURITY UPDATE: P2P discovery heap overflow
    - debian/patches/CVE-2021-0326.patch: P2P: Fix copying of secondary
      device types for P2P group client
    - CVE-2021-0326
  * SECURITY UPDATE: UPnP SUBSCRIBE misbehavior in WPS AP
    - debian/patches/CVE-2020-12695-1.patch: WPS UPnP: Do not allow
      event subscriptions with URLs to other networks
    - debian/patches/CVE-2020-12695-2.patch: WPS UPnP: Fix event message
      generation using a long URL path
    - debian/patches/CVE-2020-12695-3.patch: WPS UPnP: Handle HTTP
      initiation failures for events more properly
    - CVE-2020-12695

 -- Steve Beattie <sbeattie@ubuntu.com>  Tue, 09 Feb 2021 22:30:21 -0800

wpa (2:2.6-15ubuntu2.6) bionic; urgency=medium

  * debian/patches/fix-dbus-getall-request.patch:
    - update to a fixed version of the patch to not error out when not
      in AP mode, thanks Michael Nazzareno Trimarchi (lp: #1899262)

 -- Sebastien Bacher <seb128@ubuntu.com>  Wed, 11 Nov 2020 10:50:58 +0100

wpa (2:2.6-15ubuntu2.5) bionic-security; urgency=medium

   * SECURITY UPDATE: Incorrect indication of disconnection in certain
     situations
     - debian/patches/CVE-2019-16275.patch: silently ignore management
       frame from unexpected source address in src/ap/drv_callbacks.c,
       src/ap/ieee882_11.c.
     - CVE-2019-16275

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Tue, 17 Sep 2019 08:45:06 -0300

wpa (2:2.6-15ubuntu2.4) bionic-security; urgency=medium

  * SECURITY UPDATE: SAE/EAP-pwd side-channel attack w/Brainpool curves
    - debian/patches/CVE-2019-13377-2.patch: use const_time_memcmp() for
      pwd_value >= prime comparison in src/eap_common/eap_pwd_common.c.
    - debian/patches/CVE-2019-13377-3.patch: use BN_bn2binpad() or
      BN_bn2bin_padded() if available in src/crypto/crypto_openssl.c.
    - debian/patches/CVE-2019-13377-5.patch: run through prf result
      processing even if it >= prime in src/eap_common/eap_pwd_common.c.
    - debian/patches/CVE-2019-13377-pre6.patch: disallow ECC groups with a
      prime under 256 bits in src/eap_common/eap_pwd_common.c.
    - debian/patches/CVE-2019-13377-6.patch: disable use of groups using
      Brainpool curves in src/eap_common/eap_pwd_common.c.
    - CVE-2019-13377

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 13 Aug 2019 14:07:43 -0400

wpa (2:2.6-15ubuntu2.3) bionic-security; urgency=medium

  * SECURITY UPDATE: EAP-pwd DoS via unexpected fragment
    - debian/patches/CVE-2019-11555-1.patch: fix reassembly buffer handling
      in src/eap_server/eap_server_pwd.c.
    - debian/patches/CVE-2019-11555-2.patch: fix reassembly buffer handling
      in src/eap_peer/eap_pwd.c.
    - CVE-2019-11555

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 01 May 2019 09:58:51 -0400

wpa (2:2.6-15ubuntu2.2) bionic-security; urgency=medium

  * SECURITY UPDATE: Multiple security issues
    - debian/patches/VU-871675/*.patch: backported upstream patches.
    - CVE-2019-9495
    - CVE-2019-9497
    - CVE-2019-9498
    - CVE-2019-9499

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 08 Apr 2019 14:19:24 -0400

wpa (2:2.6-15ubuntu2.1) bionic-security; urgency=medium

  * SECURITY UPDATE: Expose sensitive information
    - debian/patches/CVE-2018-14526.patch: fix in src/rsn_supp/wpa.c.
    - CVE-2018-14526

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Thu, 09 Aug 2018 11:34:33 -0300

wpa (2:2.6-15ubuntu2) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 16:55:53 +0000

wpa (2:2.6-15ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/patches/wpa_service_ignore-on-isolate.patch: add
      IgnoreOnIsolate=yes so that when switching "runlevels" in oem-config
      will not kill off wpa and cause wireless to be unavailable on first
      boot.
    - debian/patches/session-ticket.patch: disable the TLS Session Ticket
      extension to fix auth with 802.1x PEAP on some hardware.
    - debian/patches/android_hal_fw_path_change.patch: add a DBus method
      for requesting a firmware change when working with the Android HAL;
      this is used to set a device in P2P or AP mode; conditional to
      CONFIG_ANDROID_HAL being enabled.
    - debian/config/wpasupplicant/linux: enable CONFIG_ANDROID_HAL.
    - debian/control: Build-Depends on android-headers to get the required
      wifi headers for the HAL support.
    - debian/patches/dbus-available-sta.patch: Make the list of connected
      stations available on DBus for hotspot mode; along with some of the
      station properties, such as rx/tx packets, bytes, capabilities, etc.
  * Updated debian/patches/dbus-available-sta.patch for new getter API
    and refreshed other patches.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Jan 2018 19:47:17 +0100

wpa (2:2.6-15) unstable; urgency=medium

  * Update debian/control:
    - Update Maintainer field to point to $package@packages.debian.org
    - Update Vcs-* fields to point to salsa.d.o
    - Drop no longer active uploaders.


